config/routes.rb
Rails.application.routes.draw do
  resources :user_stocks, only: [:create, :destroy]
  devise_for :users
  root "welcome#index"
  get 'portfolio', to: "users#portfolio"
  get 'search_stock' ,to: "stocks#search"
  get 'friends', to: 'users#friends'
  get 'search_friend', to: 'users#search'
  resources :friendships, only: [:create, :destroy]
  resources :users, only: [:show]
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/friendship.rb
class Friendship < ApplicationRecord
  belongs_to :user
  belongs_to :friend, class_name: 'User'
end

app/models/stock.rb
class Stock < ApplicationRecord
  has_many :user_stocks
  has_many :users, through: :user_stocks

  validates :name, :ticker, presence: true

  def self.get_ticker_price(ticker_symbol)
    client = IEX::Api::Client.new(publishable_token: Rails.application.credentials.iex_client[:sandbox_publishable_token],
                                  secret_token: Rails.application.credentials.iex_client[:sandbox_secret_token],
                                  endpoint: 'https://sandbox.iexapis.com/v1')
    begin
      new(name: client.company(ticker_symbol).company_name, ticker: ticker_symbol, price: client.price(ticker_symbol))
    rescue => exception
      return nil
    end
  end

  def self.is_stock_present?(ticker)
    find_by(ticker: ticker)
  end
end

app/models/user.rb
class User < ApplicationRecord
  has_many :user_stocks
  has_many :stocks, through: :user_stocks

  # self reference
  has_many :friendships
  has_many :friends, through: :friendships

  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable

  def check_stock_in_portfolio(ticker)
    stocks.find_by(ticker: ticker).present?
  end

  def less_than_limit
    stocks.count < 10
  end

  def full_name
    return "#{first_name} #{last_name}" if first_name || last_name
    "-"
  end

  def self.matches(field, input)
    where("#{field} like ?", "%#{input}%")
  end

  def self.friend_search(input)
    input.strip!
    result = (matches("first_name", input) + matches("last_name", input) + matches("email", input)).uniq
    return nil unless result
    result
  end

  def except_current_user(friends)
    friends.reject {|friend| friend.id == self.id } 
  end

  def is_friend?(friend_id)
    friends.exists?(id: friend_id)
  end

  def stock_already_in_portfolio?(stock_id)
    stocks.exists?(id: stock_id)
  end
end

app/models/user_stock.rb
class UserStock < ApplicationRecord
  belongs_to :user
  belongs_to :stock
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  before_action :authenticate_user!
  before_action :configure_permitted_parameters, if: :devise_controller?

  protected

  def configure_permitted_parameters
    devise_parameter_sanitizer.permit(:sign_up, keys: [:first_name, :last_name])
    devise_parameter_sanitizer.permit(:account_update, keys: [:first_name, :last_name])
  end
end

app/controllers/friendships_controller.rb
class FriendshipsController < ApplicationController
  def create
    friend = User.find(params[:id])
    Friendship.create(user: current_user, friend: friend)
    flash[:notice] = "Successfully added in friend list"
    redirect_to friends_path
  end

  def destroy
    friend = User.find(params[:id])
    user_friend = Friendship.where(user_id: current_user.id, friend_id: friend.id).first
    user_friend.destroy
    flash[:notice] = "#{friend.full_name} successfully removed"
    redirect_to friends_path
  end
end

app/controllers/stocks_controller.rb
class StocksController < ApplicationController
  def search
    if params[:stock].present?
      @stock = Stock.get_ticker_price(params[:stock])
      if @stock
        respond_to do |format|
          format.js { render partial: 'users/stock_data.js' }
        end
      else
        respond_to do |format|
          flash.now[:alert] = 'Please enter correct ticker symbol'
          format.js { render partial: 'users/stock_data.js' }
        end
      end
    else
      respond_to do |format|
        flash.now[:alert] = 'Please enter ticker symbol'
        format.js { render partial: 'users/stock_data.js' }
      end
    end
  end
end

app/controllers/user_stocks_controller.rb
class UserStocksController < ApplicationController
  def create
    stock = Stock.is_stock_present?(params[:ticker])
    if stock.blank?
      stock = Stock.get_ticker_price(params[:ticker])
      stock.save
    end
    UserStock.create(user: current_user, stock: stock)
    flash[:notice] = 'Successfully added in portfolio'
    redirect_to portfolio_path
  end

  def destroy
    stock = Stock.find(params[:id])
    user_stock = UserStock.where(user_id: current_user.id, stock_id: stock.id).first
    user_stock.destroy
    # current_user.stocks.find(params[:id]).destroy
    flash[:notice] = "#{stock.ticker} was successfully removed"
    redirect_to portfolio_path
  end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  def portfolio
    @user = current_user
    @tracked_stocks = current_user.stocks
  end

  def friends
    @friends = current_user.friends
  end

  def show
    @user = User.find(params[:id])
    @tracked_stocks = @user.stocks
  end

  def search
    if params[:friend].present?
      @friends = User.friend_search(params[:friend])
      @friends = current_user.except_current_user(@friends)
      unless @friends.empty?
        respond_to do |format|
          format.js { render partial: 'users/friend_data.js' }
        end
      else
        respond_to do |format|
          @friends = nil
          flash.now[:alert] = 'Please enter correct friend info'
          format.js { render partial: 'users/friend_data' }
        end
      end
    else
      respond_to do |format|
        flash.now[:alert] = 'Please enter friend info'
        format.js { render partial: 'users/friend_data.js' }
      end
    end
  end
end

app/controllers/welcome_controller.rb
class WelcomeController < ApplicationController
  def index
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/views/friends/_list.html.erb
<div class="row mt-3">
  <div class="col-9">  
    <table class="table table-bordered table-hover">
      <thead>
        <tr>
          <th scope="col">First Name</th>
          <th scope="col">Last Name</th>
          <th scope="col">Email</th>
          <th scope="col">Actions</th>
        </tr>
      </thead>
      <tbody>
        <% @friends.each do |friend| %>
          <tr>
            <td><%= friend.first_name %></td>
            <td><%= friend.last_name %></td>
            <td><%= friend.email %></td>
            <td>
              <%= link_to 'View Profile', user_path(friend), class: "btn btn-outline-success ml-2" %>
              <%= link_to 'Remove', friendship_path(id: friend.id), class: 'btn btn-outline-danger', method: :delete, data: {confirm: "Are you sure?"} %>
            </td>
          </tr> 
        <% end %>
      </tbody>
    </table>
  </div>
</div>

app/views/layouts/_flash_messages.html.erb
<div class="container">
  <% flash.each do |name, message| %>
    <% klass = "alert-success" %>
    <% klass = "alert-danger" if name == 'alert' %>
    <div class="alert <%= klass %> alert-dismissible fade show" role="alert">
      <%= message %>
      <button type="button" class="close" data-dismiss="alert" aria-label="Close">
        <span aria-hidden="true">&times;</span>
      </button>
    </div>
  <% end %>
</div>

app/views/layouts/_navigation.html.erb
<nav class="navbar navbar-expand-lg navbar-light bg-light">
  <div class="container">
    <%= link_to 'Fintrack', root_path, class: "navbar-brand" %>
    <% if current_user %>
      <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
      </button>

      <div class="collapse navbar-collapse" id="navbarSupportedContent">
        <ul class="navbar-nav mr-auto">
          <li class="nav-item <%= 'active' if request.path == portfolio_path %>">
            <%= link_to 'Portfolio', portfolio_path, class: "nav-link" %>
          </li>
          <li class="nav-item <%= 'active' if request.path == friends_path %>">
            <%= link_to 'Friends', friends_path, class: "nav-link" %>
          </li>
          <li class="nav-item dropdown">
            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
              <%= fa_icon 'user' %> <%= current_user.full_name %>
            </a>
            <div class="dropdown-menu" aria-labelledby="navbarDropdown">
              <%= link_to 'Edit profile', edit_user_registration_path, class: "dropdown-item" %>
              <div class="dropdown-divider"></div>
              <a class="dropdown-item" href="#">Something else here</a>
            </div>
          </li>
        </ul>
        <form class="form-inline my-2 my-lg-0">
          <%= link_to 'Log out', destroy_user_session_path, class: "btn btn-outline-danger mr-2 my-sm-0", method: :delete %>
          <input class="form-control mr-sm-2" type="search" placeholder="Search" aria-label="Search">
          <button class="btn btn-outline-success my-2 my-sm-0" type="submit">Search</button>
        </form>
      </div>
    <% end %>
  </div>
</nav>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Fintrack</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= render 'layouts/navigation' %>
    <div class="container">
      <%= render 'layouts/flash_messages' %>
      <%= yield %>
    </div>
  </body>
</html>

app/views/stocks/_list.html.erb
<div class="row mt-3">
  <div class="col-9">  
    <table class="table table-bordered table-hover">
      <thead>
        <tr>
          <th scope="col">Ticker</th>
          <th scope="col">Name</th>
          <th scope="col">Price</th>
          <th scope="col">Actions</th>
        </tr>
      </thead>
      <tbody>
        <% @tracked_stocks.each do |stock| %>
          <tr>
            <td><%= stock.ticker %></td>
            <td><%= stock.name %></td>
            <td><%= stock.price %></td>
            <% if current_user == @user %>
              <td><%= link_to 'Remove', user_stock_path(id: stock.id), method: :delete, class: "btn btn-outline-danger", data: {confirm: "Are you sure?"} %></td>
            <% else %>
              <% unless current_user.stock_already_in_portfolio?(stock) %>
                <td><%= link_to 'Add to portfolio', user_stocks_path(ticker: stock.ticker), method: :post, class: "btn btn-outline-success ml-3 my-sm-0" %></td>
              <% else %>
                <td>
                  <span class="badge badge-secondary">
                    You are already tracking this stock
                  </span>
                </td>
              <% end %>
            <% end %>
          </tr> 
        <% end %>
      </tbody>
    </table>
  </div>
</div>

app/views/users/_friend_data.html.erb
<div class="results-block">
  <%= render 'layouts/flash_messages' %>
</div>

<% if @friends %>
  <div class="card card-header results-block">
    <table class="col-md-12">
      <tbody>
        <% @friends.each do |friend| %>
          <tr>
            <td><strong>Name: </strong> <%= friend.full_name %></td>
            <td><strong>Email: </strong> <%= friend.email %></td>
            <td><strong>Actions: </strong> <%= link_to 'View Profile', user_path(friend), class: "btn btn-outline-success ml-2" %></td>
            <td>
              <% if current_user.is_friend?(friend) %>
                <span class="badge badge-secondary ml-2">
                  You are friends
                </span>
              <% else %>
                <%= link_to 'Add', friendships_path(id: friend.id), method: :post, class: "btn btn-outline-success ml-3 my-sm-0" %>
              <% end %>
            </td>
          </tr>
        <% end %>
      </tbody>
    </table>
  </div>
<% end %>

app/views/users/_friend_data.js.erb
document.querySelector("#friend_data").innerHTML = "<%= j render 'users/friend_data.html' %>"

app/views/users/_stock_data.html.erb
<div class="results-block">
  <%= render 'layouts/flash_messages' %>
</div>

<% if @stock %>
  <div class="card card-header results-block">
    <strong>Symbol: </strong> <%= @stock.ticker %>
    <strong>Name: </strong> <%= @stock.name %>
    <strong>Price: </strong> <%= @stock.price %>
    <% if !current_user.check_stock_in_portfolio(@stock.ticker) and current_user.less_than_limit %>
      <%= link_to 'Add to portfolio', user_stocks_path(ticker: @stock.ticker), method: :post, class: "btn btn-outline-success ml-3 my-sm-0" %>
    <% else %>
      <span class="badge badge-secondary">
        You are already tracking
        <% if current_user.check_stock_in_portfolio(@stock.ticker) %>
          this stock
        <% else %>
          10 stocks
        <% end %>
      </span>
    <% end %>
  </div>
<% end %>

app/views/users/_stock_data.js.erb
document.querySelector("#stock_data").innerHTML = "<%= j render 'users/stock_data.html' %>"

app/views/users/friends.html.erb
<h1 class= "mt-5">Friends</h1>

<div class='search-area'>
  <h3>Search Friends</h3>
  <%= form_tag search_friend_path, remote: true, method: :get do %>
    <div class="form-group row">
      <div class="col-sm-9 no-right-padding">
        <%= text_field_tag :friend, params[:friend], placeholder: "Stock ticker symbol", autofocus: true, class: "form-control form-control-lg" %>
      </div>
      <div class="col-sm-3 no-left-padding">
        <%= button_tag type: :submit, class: "btn btn-success" do %>
          <%= fa_icon 'search 2x' %>
        <% end %>
      </div>
    </div>
  <% end %>
</div>

<div id="friend_data"></div>

<% unless @friends.empty? %>
  <%= render 'friends/list' %>
<% end %>

app/views/users/portfolio.html.erb
<h1 class= "mt-5">Portfolio</h1>

<div class='search-area'>
  <h3>Search Stocks</h3>
  <%= form_tag search_stock_path, remote: true, method: :get do %>
    <div class="form-group row">
      <div class="col-sm-9 no-right-padding">
        <%= text_field_tag :stock, params[:stock], placeholder: "Stock ticker symbol", autofocus: true, class: "form-control form-control-lg" %>
      </div>
      <div class="col-sm-3 no-left-padding">
        <%= button_tag type: :submit, class: "btn btn-success" do %>
          <%= fa_icon 'search 2x' %>
        <% end %>
      </div>
    </div>
  <% end %>
</div>

<div id="stock_data"></div>

<% if @tracked_stocks.count > 0 %>
  <%= render 'stocks/list' %>
<% end %> 

app/views/users/show.html.erb
<h1 class= "mt-5">User Details</h1>

<div class="card card-header results-block">
  <strong>Name: </strong> <%= @user.full_name %>
  <strong>Email: </strong> <%= @user.email %>
  <% if current_user.is_friend?(@user) %>
    <span class="badge badge-secondary ml-2">
      You are friends
    </span>
  <% else %>
    <%= link_to 'Add', friendships_path(id: @user.id), method: :post, class: "btn btn-outline-success ml-3 my-sm-0" %>
  <% end %>
</div>

<% if @tracked_stocks.count > 0 %>
  <%= render 'stocks/list' %>
<% end %> 

app/views/welcome/index.html.erb
<div class="container" id="home-container">
  <div class="jumbotron text-center text-white">
    <h1 class="display-4">Fintrack</h1>
    <p class="lead">Tracking your money is the process of monitoring and keeping a record of your income and expenses. It enables you to identify bad spending habits, and make adjustments to improve your finances.
    </p>
</div>